/*
	$Id: Constants.java 170 2006-04-08 21:16:55Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.util.ArrayList;
import java.io.PrintWriter;

/**
   󷿤ΥåȤǤ
*/
public class Constants implements Components {

    /** Υꥹ */
    private ArrayList<Constant> v;

    /**
       ΥåȤޤ

       @param gm 롼ץޥ͡
       @param nodes constantǤΥΡɥꥹ
    */
    public Constants(final GroupManager gm, final NodeList nodes) {
	v = new ArrayList<Constant>();

	if (nodes == null) {
	    return;
	}
	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    v.add(gm.createConstant(elem));
	}
    }

    public void printCode(final PrintWriter wr, final String indent) {
	Constant m;
	int n = v.size();

	if (n == 0) {
	    return;
	}
	--n;
	for (int k = 0; k < n; ++k) {
	    m = (Constant) v.get(k);
	    wr.println(indent + m.getCode() + ",");
	}
	m = (Constant) v.get(n);
	wr.println(indent + m.getCode());
    }

    public void printSummary(final PrintWriter wr) {
	for (Constant m : v) {
	    m.printSummary(wr);
	}
    }

    public void printDetail(final PrintWriter wr) {
	for (Constant m : v) {
	    m.printDetail(wr);
	}
    }

    public void printTexDetail(final PrintWriter wr) {
	wr.println("\\begin{description}");
	for (Constant m : v) {
	    m.printTexDetail(wr);
	}
	wr.println("\\end{description}");
    }
}
